maph 1.0.0 High-Performance Memory-Mapped Key-Value Database with O(1) Lookups

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Static Public Attributes | List of all members
maph::FastSlot Struct Reference

`#include <maph_fast.hpp>`

Collaboration diagram for maph::FastSlot:

## Public Member Functions
uint32_t | get_hash () const
uint32_t | get_version () const
void | set_hash_version (uint32_t hash, uint32_t version)
bool | is_empty () const

## Public Attributes
std::atomic< uint64_t > | hash_and_version {0}
uint32_t | size {0}
char | value [500] {}

## Static Public Attributes
static constexpr uint64_t | EMPTY = 0

## Detailed Description

Definition at line 20 of file maph_fast.hpp.

## Member Function Documentation

## ◆ get_hash()

uint32_t maph::FastSlot::get_hash | ( |  | ) | const
| inline

Definition at line 28 of file maph_fast.hpp.

References hash_and_version.

Referenced by maph::FastMaph::dynamic_set(), maph::FastMaph::get(), and maph::FastMaph::scan().

Here is the caller graph for this function:

## ◆ get_version()

uint32_t maph::FastSlot::get_version | ( |  | ) | const
| inline

Definition at line 32 of file maph_fast.hpp.

References hash_and_version.

Referenced by maph::FastMaph::batch_set(), maph::FastMaph::dynamic_set(), and maph::FastMaph::set().

Here is the caller graph for this function:

## ◆ is_empty()

bool maph::FastSlot::is_empty | ( |  | ) | const
| inline

Definition at line 40 of file maph_fast.hpp.

References hash_and_version.

Referenced by maph::FastMaph::scan().

Here is the caller graph for this function:

## ◆ set_hash_version()

void maph::FastSlot::set_hash_version | ( | uint32_t | hash,
|  | uint32_t | version
| ) |  |
| inline

Definition at line 36 of file maph_fast.hpp.

References hash_and_version.

Referenced by maph::FastMaph::batch_set(), maph::FastMaph::dynamic_set(), and maph::FastMaph::set().

Here is the caller graph for this function:

## Member Data Documentation

## ◆ EMPTY

constexpr uint64_t maph::FastSlot::EMPTY = 0
| static constexpr

Definition at line 25 of file maph_fast.hpp.

## ◆ hash_and_version

std::atomic<uint64_t> maph::FastSlot::hash_and_version {0}

Definition at line 21 of file maph_fast.hpp.

Referenced by get_hash(), get_version(), is_empty(), and set_hash_version().

## ◆ size

uint32_t maph::FastSlot::size {0}

Definition at line 22 of file maph_fast.hpp.

Referenced by maph::FastMaph::batch_set(), maph::FastMaph::dynamic_set(), maph::FastMaph::get(), maph::FastMaph::scan(), and maph::FastMaph::set().

## ◆ value

char maph::FastSlot::value[500] {}

Definition at line 23 of file maph_fast.hpp.

Referenced by maph::FastMaph::batch_set(), maph::FastMaph::dynamic_set(), maph::FastMaph::get(), maph::FastMaph::scan(), and maph::FastMaph::set().

The documentation for this struct was generated from the following file:

- include/maph/maph_fast.hpp